import os
import app.util
import app.servicecontrol

class ServiceController(app.servicecontrol.ServiceController):

    def getPidFile(self):
        return '/var/run/mongodb/mongod.pid'

    def __runInit(self, verb):
        config = app.util.getRuntimeConfiguration()
        logFile = os.path.join(config['MONGODB_LOG_DIR'], 'service.log')
        initScript = '/etc/init.d/mongod'
        return os.system("%s %s < /dev/null >> %s 2>&1 &" % (initScript, verb, logFile)) == 0

    def startDaemonAsync(self):
        return self.__runInit("start")

    def stopDaemonAsync(self):
        return self.__runInit("stop")

    def isBootstrapped(self):
        config = app.util.getRuntimeConfiguration()
        return os.path.isdir(config['MONGODB_DATA_DIR'])
